'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

/**
 * This function takes an extension function that is expecting a `RemoteRoot` as its
 * first argument, and returns a new function that accepts a `RemoteChannel` instead.
 * This is a convenience that allows the raw UI extension API to only expose the simpler
 * `RemoteChannel` type, while allowing the extension to use the more powerful `RemoteRoot`,
 * provided by a version of `@remote-ui/core` that the extension controls.
 */
function createExtensionRegistrationFunction() {
  const extensionWrapper = (target, implementation) => {
    var _shopify;
    (_shopify = globalThis.shopify) === null || _shopify === void 0 ? void 0 : _shopify.extend(target, implementation);
    return implementation;
  };
  return extensionWrapper;
}

exports.createExtensionRegistrationFunction = createExtensionRegistrationFunction;
