import { createExtensionRegistrationFunction } from './unified/utilities/registration.mjs';

/**
 * Registers your UI Extension to run for the selected extension point.
 *
 * @param target The extension point you are registering for.
 *
 * @param implementation The function that will be called when Checkout begins rendering
 * your extension. This function is called with the API checkout provided to your
 * extension.
 */
const extension = createExtensionRegistrationFunction();

/**
 * Registers your UI Extension to run for the selected extension point.
 *
 * @param target The extension point you are registering for.
 *
 * @param implementation The function that will be called when Checkout begins rendering
 * your extension. This function is called with the API checkout provided to your
 * extension.
 */
const extend = extension;

export { extend, extension };
