export interface ChoiceProps {
    /**
     * A unique identifier for the choice.
     */
    id: string;
    /**
     * Whether the choice can be changed.
     */
    disabled?: boolean;
    /**
     * A label used for buyers using assistive technologies. When set, any
     * `children` supplied to this component will not be announced to screen reader users.
     */
    accessibilityLabel?: string;
}
/**
 * Options inside a `ChoiceList`.
 * The wrapping `ChoiceList` component will dictate if the choice renders as radio buttons or checkboxes.
 */
export declare const Choice: "Choice" & {
    readonly type?: "Choice" | undefined;
    readonly props?: ChoiceProps | undefined;
    readonly children?: true | undefined;
};
//# sourceMappingURL=Choice.d.ts.map